DIM SHARED AS STRING NL
#IF DEFINED(__FB_UNIX__)
 NL = CHR(10)
 #DEFINE DIR_NAME MID(CURDIR, INSTRREV(CURDIR, "/") + 1)
#ELSE
 NL = CHR(13, 10)
 #DEFINE DIR_NAME MID(CURDIR, INSTRREV(CURDIR, "\") + 1)
#ENDIF
#DEFINE TRIMM ANY !" \t\r\n\f\v"
#DEFINE H2BI_FILE_SUFFIX ".h2bi"
#DEFINE BI_FILE_SUFFIX ".bi"
#DEFINE FLAGS_SUFFIX "(){};"
#DEFINE GEANY_FILE "Geany"
#DEFINE TYKENN "_"
#DEFINE FILE_START(_P_) "' " & RIGHT(STR(_P_ + 1000), 3) & " start from: "
#DEFINE FILE_BACK(_P_) "' " & RIGHT(STR(_P_ + 1000), 3) & " back from "

#DEFINE OUT_TEXT {!"\t", "DIM ", "STATIC ", "EXTERN ", "CONST ", "TYPE "}
ENUM
  OUT_Tabz = 0
  OUT_DIM
  OUT_STATIC
  OUT_EXTERN
  OUT_CONST
  OUT_TYPE
  OUT_SUB = 1 SHL 3
  OUT_FUNC = 1 SHL 4
  OUT_FUNC_PTR = 1 SHL 5
END ENUM

' the following blocks are to define options for '-P_' groups:
' C = config file handling (.h2bi)
' I = input handling (source and comments of .h files)
' O = output handling (FB source generation in .bi)
' P = protocol generation (in .bi)
' T = translations (in .bi)

' how to handle the config file (.h2bi)
' Behandlung der Konfigurationsdatei (wirkt nicht bei aktueller Bearbeitung)
#DEFINE DEFAULT_FLC &hFFFFFFFF
TYPE C_Flags
#DEFINE KEY_START "__START_BI__"
#DEFINE TCST "ST"
  AS ULONG ST : 1 ' read start sections
#DEFINE KEY_END "__END_BI__"
#DEFINE TCEN "EN"
  AS ULONG EN : 1 ' read end sections
#DEFINE KEY_TYPES "__TYPES__"
#DEFINE TCTY "TY"
  AS ULONG TY : 1 ' read types sections
#DEFINE KEY_HEADERS "__HEADERS__"
#DEFINE TCHR "HR"
  AS ULONG HR : 1 ' read header sections
#DEFINE KEY_PARAMETERS "__PARAMETERS__"
#DEFINE TCPA "PA"
  AS ULONG PA : 1 ' read parameter sections
#DEFINE KEY_FOLDERS "__FOLDERS__"
#DEFINE TCFO "FO"
  AS ULONG FO : 1 ' read folder sections
#DEFINE KEY_MACROS "__MACROS__"
#DEFINE TCMA "MA"
  AS ULONG MA : 1 ' read macro sections
#DEFINE TCPO "PO"
#DEFINE KEY_POST_REPS "__POST_REPS__"
  AS ULONG PO : 1 ' read POST sections
#DEFINE TCDT "DT"
  AS ULONG DT : 1 ' use default type replacements
#DEFINE TCDH "DH"
  AS ULONG DH : 1 ' use default file replacements
END TYPE

' how to handle the input (.h files)
' Kommentare aus Headerdateien
#DEFINE DEFAULT_FLI &hFFFFFF1F
TYPE I_Flags
  AS ULONG RES1 : 1 ' reserved
  AS ULONG RES2 : 1 ' reserved
  AS ULONG COMM : 1
  AS ULONG CODE : 1 ' output y/n (internal use only)
#DEFINE FLI_MASK_CC &b11000000
#DEFINE FLI_MASK_CS &hFFFFFF00
' how to show source and comments
#DEFINE TISC "SC"
  AS ULONG SHCC : 1 ' show C comments
#DEFINE TISB "SB"
  AS ULONG BLCO : 1 ' show C comments in Blocks
#DEFINE TICS "CS"
  AS ULONG CSKO : 1 ' compress C source
#DEFINE TICC "CC"
  AS ULONG CCKO : 1 ' compress C comments
' which source to show
#DEFINE TIBE "BE"
  AS ULONG BE : 1 ' ENUM blocks
#DEFINE TIBU "BU"
  AS ULONG BU : 1 ' UNION blocks
#DEFINE TIBT "BT"
  AS ULONG BT : 1 ' TYPE blocks
#DEFINE TITY "TY"
  AS ULONG TY : 1 ' TYPE lines
#DEFINE TIDI "DI"
  AS ULONG DI : 1 ' DIM lines
#DEFINE TIST "ST"
  AS ULONG ST : 1 ' STATIC lines
#DEFINE TICO "CO"
  AS ULONG CO : 1 ' CONST lines
#DEFINE TIEX "EX"
  AS ULONG EX : 1 ' EXTERN lines
#DEFINE TIDE "DE"
  AS ULONG DE : 1 ' DECLARE lines
#DEFINE TIPD "PD"
  AS ULONG PD : 1 ' #DEFINE line
#DEFINE TIPE "PE"
  AS ULONG PE : 1 ' #ERROR lines
#DEFINE TIPI "PI"
  AS ULONG PI : 1 ' #INCLUDE lines
#DEFINE TIPU "PU"
  AS ULONG PU : 1 ' #UNDEF lines
#DEFINE TIPX "PX"
  AS ULONG PX : 1 ' #IFDEF, #IFNDEF, #IF, #ELSEIF, #ENDIF lines
#DEFINE TICA "CA"
  AS ULONG CA : 1 ' all CAST replacements
#DEFINE TIER "ER"
  AS ULONG ER : 1 ' all translation with error
#DEFINE TIUT "UT"
  AS ULONG UT : 1 ' all untranslated C line(s)
END TYPE

' how to generate output (.bi file)
' Generierung der Ergebnisdatei
#DEFINE DEFAULT_FLO &hFFFFFFFE
TYPE O_Flags
#DEFINE TOAL "AL"
  AS ULONG AL : 1 ' use ALIAS for SUBs/FUNCTIONs (off)
#DEFINE TOWR "WR"
  AS ULONG WR : 1 ' wrap parameter lists (on)
#DEFINE TONA "NA"
  AS ULONG NA : 1 ' use names in parameter lists (on)
#DEFINE TOBV "BV"
  AS ULONG BV : 1 ' use BYVAL in parameter lists (on)
#DEFINE TOCD "CD"
  AS ULONG CD : 1 ' use CDECL for parameter lists (on)
#DEFINE TONT "NT"
  AS ULONG NT : 1 ' "0 TO " in field dimension (on)
#DEFINE TOUD "UD"
  AS ULONG UD : 1 ' uncomment unsave #DEFINE lines (on)
#DEFINE TOUC "UC"
  AS ULONG UC : 1 ' mark unsave CASTs (on)
#DEFINE TOMF "MF"
  AS ULONG MF : 1 ' mark file include (on)
#DEFINE TOMI "MI"
  AS ULONG MI : 1 ' mark #else/#endif for #if/#ifdef/#ifndef (on)
#DEFINE TOMB "MB"
  AS ULONG MB : 1 ' mark place of untranslated blocks {static inline} (on)
#DEFINE TOER "ER"
  AS ULONG ER : 1 ' mark error lines with BIN # (on)
#DEFINE TOET "ET"
  AS ULONG ET : 1 ' mark error lines with text instead of BIN# (on)
#DEFINE TOSI "SI"
  AS ULONG SI : 1 ' single file output = all-in-one (on)
END TYPE

' how to generate the protocol (end of .bi file)
' Generierung des Protokolls
#DEFINE DEFAULT_FLP &hFFFFFFFF
TYPE P_Flags
#DEFINE TPNA "NA"
  AS ULONG NA : 1 ' show name of .bi file (on)
#DEFINE TPPA "PA"
  AS ULONG PA : 1 ' show parameters command line/.h2bi file (on)
#DEFINE TPTI "TI"
  AS ULONG TI : 1 ' show process time (on)
#DEFINE TPBY "BY"
  AS ULONG BY : 1 ' show number of translated bytes (on)
#DEFINE TPDE "DE"
  AS ULONG DE : 1 ' show deepness info (on)
#DEFINE TPNS "NS"
  AS ULONG NS : 1 ' show number of SUB/FUNCTION names (on)
#DEFINE TPLS "LS"
  AS ULONG LS : 1 ' show list of SUB/FUNCTION names (on)
#DEFINE TPNX "NX"
  AS ULONG NX : 1 ' show number of mangled TYPE names (on)
#DEFINE TPLX "LX"
  AS ULONG LX : 1 ' show list of mangled TYPE names (on)
#DEFINE TPNF "NF"
  AS ULONG NF : 1 ' show number of input files (on)
#DEFINE TPLF "LF"
  AS ULONG LF : 1 ' show list of input files (on)
#DEFINE TPNY "NY"
  AS ULONG NY : 1 ' show number of missed input files (on)
#DEFINE TPLY "LY"
  AS ULONG LY : 1 ' show list of missed input files (on)
#DEFINE TPND "ND"
  AS ULONG ND : 1 ' show number of FOLDERS (on)
#DEFINE TPLD "LD"
  AS ULONG LD : 1 ' show list of FOLDERS (on)
#DEFINE TPNM "NM"
  AS ULONG NM : 1 ' show number of MACROS (on)
#DEFINE TPLM "LM"
  AS ULONG LM : 1 ' show list of MACROS (on)
#DEFINE TPNH "NH"
  AS ULONG NH : 1 ' show number of HEADERS replacements (on)
#DEFINE TPLH "LH"
  AS ULONG LH : 1 ' show list of HEADERS replacements (on)
#DEFINE TPNT "NT"
  AS ULONG NT : 1 ' show number of TYPES replacements (on)
#DEFINE TPLT "LT"
  AS ULONG LT : 1 ' show list of TYPES replacements (on)
#DEFINE TPNP "NP"
  AS ULONG NP : 1 ' show number of POST replacements (on)
#DEFINE TPLP "LP"
  AS ULONG LP : 1 ' show list of POST replacements (on)
END TYPE

' how to translate, switch single translations (.bi file)
' Welche Uebersetzungen werden generiert
#DEFINE DEFAULT_FLT &hFFFFFFFF
TYPE T_Flags
#DEFINE TTDE "DE"
  AS ULONG DE : 1 ' translate DECLARE lines (on)
#DEFINE TTDI "DI"
  AS ULONG DI : 1 ' translate DIM lines (on)
#DEFINE TTTY "TY"
  AS ULONG TY : 1 ' translate TYPE lines (on)
#DEFINE TTST "ST"
  AS ULONG ST : 1 ' translate STATIC lines (on)
#DEFINE TTEX "EX"
  AS ULONG EX : 1 ' translate EXTERN lines (on)
#DEFINE TTCO "CO"
  AS ULONG CO : 1 ' translate CONST lines (on)
#DEFINE TTBT "BT"
  AS ULONG BT : 1 ' translate TYPE blocks (on)
#DEFINE TTBU "BU"
  AS ULONG BU : 1 ' translate UNION blocks (on)
#DEFINE TTBE "BE"
  AS ULONG BE : 1 ' translate ENUM blocks (on)
#DEFINE TTPD "PD"
  AS ULONG PD : 1 ' translate preprocessor define (on)
#DEFINE TTPE "PE"
  AS ULONG PE : 1 ' translate preprocessor error (on)
#DEFINE TTPI "PI"
  AS ULONG PI : 1 ' translate preprocessor include (on)
#DEFINE TTPU "PU"
  AS ULONG PU : 1 ' translate preprocessor undef (on)
#DEFINE TTPX "PX"
  AS ULONG PX : 1 ' translate preprocessor if/else (on)
#DEFINE TTCS "CS"
  AS ULONG CS : 1 ' translate save CAST (on)
#DEFINE TTCU "CU"
  AS ULONG CU : 1 ' translate unsave CASTs (on)
#DEFINE TTII "II"
  AS ULONG II : 1 ' translate IIFS (on)
#DEFINE TTQU "QU"
  AS ULONG QU : 1 ' translate quotes: '', "" (on)
#DEFINE TTLO "LO"
  AS ULONG LO : 1 ' translate logic: &&, >>, |, ... (on)
#DEFINE TTUT "UT"
  AS ULONG UT : 1 ' use '_' extension for 'typedef a a;' (on)
#DEFINE TTUV "UV"
  AS ULONG UV : 1 ' use '_' for unnamed vars (on)
#DEFINE TTKW "KW"
  AS ULONG KW : 1 ' use '_' for extension FB keywords (on)
#DEFINE TTAN "AN"
  AS ULONG AN : 1 ' declare TYPEs without C type as ANY PTR (on)
#DEFINE TTMA "MA"
  AS ULONG MA : 1 ' expand macros recursivly (on)
#DEFINE TTPT "PT"
  AS ULONG PT : 1 ' PTR removing for SUBs/FUNCTIONs (on)
END TYPE
